/*
 ķ
   Program..: TOUCHSCR.PRG                               
   Author...: Roger J. Donnay                            
   Notice...: (c) DONNAY Software Designs 1987-2000      
   Date.....: Dec  23, 2000                              
   Notes....: Touch Screen Example                       
 Ľ

Nick Alexander (Performance Leasing, Inc)  contibuted this program
for those of you who need to create touch screen applications.

Here is a handy Keypad and Numeric Pad that can be used in
touch-screen applications.

*/
#include "DCdialog.ch"
#include "touchscr.ch"
#include "xSrvComb.ch"
FUNCTION main()

LOCAL GetList := {}, GetOptions,  nNum := 0, cString := Space(30)
nHeader := 10

@ -1, 15 DCSAY 'Enter header size' GET nHeader
@ -1,1 DCPUSHBUTTON ;
				 CAPTION 'Display Browse' ;
         SIZE 13,1.5 ;
         ACTION {|| xSrvCombBrowse(nHeader ) }

@ 1,1 DCSAY 'Enter a Number' GET nNum GETFONT '18.Courier' ;
      PICTURE '999999.99' POPUP {|n|PopNumPad(n)}

@ 3,1 DCSAY 'Enter a String' GET cString GETFONT '18.Courier' POPUP {|n|PopKeyPad(n)}

//@ 5,1 DCPUSHBUTTON ;
//				 CAPTION 'TEST BUTTON' ;
//         SIZE 13,1.5 ;
//         ACTION {|| _xServeExit( ) }

DCREAD GUI FIT ADDBUTTONS TO lOk SETAPPWINDOW ;
   TITLE 'Touch Screen Demo'

RETURN nil

* -----------

PROC AppSys()
RETURN

//NEWBEG E5135
FUNCTION _xServeExit( )
//NEWBEG S3337 -
LOCAL nMEAL
LOCAL GetList := {}, GetOptions , oNo
LOCAL oConfig2, nColor2, cSayFont, cGetFont, cHeadTitle, cSubTitle

    oConfig2 := DC_XbpPushButtonXPConfig():new()
    oConfig2:fgColorMouse    := COLOR_DARKGREEN
    oConfig2:bgColorMouse    := COLOR_ORANGE
    oConfig2:fgColor         := COLOR_DARKGREEN
    oConfig2:bgColor         := COLOR_DARKGREEN
    oConfig2:fgColorSelected := GRA_CLR_GREEN
    oConfig2:bgColorSelected := COLOR_ICEGREEN
    oConfig2:fgColorClick    := COLOR_DARKGREEN
    oConfig2:bgColorClick    := COLOR_ICEGREEN
    oConfig2:gradientStep    := 10
    oConfig2:gradientReverse := .T.
    oConfig2:radius          := 50
    oConfig2:outline         := .T.
    oConfig2:font            := cSayFont
    oConfig2:mouseOverFont   := cGetFont
    oConfig2:mouseOverScale  := 1.1
    oConfig2:bitmapOffset    := 15
    oConfig2:bitmapScale     := 1
	  oConfig2:alignBitmap     := XBPALIGN_HCENTER +XBPALIGN_VCENTER    //XBPALIGN_HCENTER +
    oConfig2:borderColor     := COLOR_BLUE

   @ 6, 1 DCSAY ''  SAYSIZE 0  COLOR GRA_CLR_WHITE, GRA_CLR_BLUE FONT '12.Arial Bold'
   @ 7, 2 DCSAY 'Are you sure you want to Quit the program?'  SAYSIZE 0  COLOR GRA_CLR_WHITE, GRA_CLR_BLUE FONT '12.Arial Bold'

   @ 10,10 DCPUSHBUTTONXP CAPTION '~Yes' ;
      SIZE 14.00,3.00 ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
		  CONFIG oConfig2 ;
      OBJECT oOk

   @ 10,40 DCPUSHBUTTONXP CAPTION '~No' ;
      SIZE 14.00,3.00 ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} ;
   	  FONT '12.Arial Bold';
		  CONFIG oConfig2 ;
   	  CARGO 'CANCEL'

   @ 11, 1 DCSAY ''  SAYSIZE 0  COLOR GRA_CLR_WHITE, GRA_CLR_BLUE FONT '12.Arial Bold'

   DCGETOPTIONS ;
        BITMAP BITMAP_BLUE

   DCREAD GUI FIT TO lOK ;
         SETFOCUS @oOk ;
         OPTIONS GetOptions ;
         TITLE 'Quit' MODAL

RETURN .T.

STATIC FUNCTION xSrvCombBrowse(nHeaderSize)
DCQDEBUG nHeaderSize
   nWindowWidth := 600
   nWindowHeight := 800
	 nMaxWidth := 600
	 nMaxHeight  := 800
   // Setup the Purchase List that will be displayed on the Right side
   // of the window..
   // Then make a place in the array for a pointer to be stored when
   // browse is called
   // Set nPointer to beginning of the array
   PRIVATE aPurList := {}
   FOR i := 1 TO 20
      AADD(aPurList, { EMPTY_ROW , 0.0, 0.0 } )
   NEXT
   FOR nPointer := 1 TO Len(aPurList)
      aPurList[nPointer,1] := Pad(aPurList[nPointer,1],10)
   NEXT
   nPointer := 1

  @ 5.5, 1.0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX ; // make box on right side
      OBJECT oStaticBox ;
      SIZE 49, 11 ;                           // columns, rows
      GROUP 'DIALOG'  RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

   @ 0, 0 DCBROWSE oBrowse ;
      DATA aPurList ;
      SIZE 55.00,11 ;   // width , height
      POINTER nPointer ;
      PRESENTATION BrowPresII(nHeaderSize) ;
      FONT '8.Helv Bold' ;
      GROUP 'DIALOG' ;
      PARENT oStaticBox  ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT ;
			RESIZECOLUMNS

   DCBROWSECOL ELEMENT 1 PARENT oBrowse HEADER 'Name ' WIDTH 15 ;
      GROUP 'DIALOG' ;
      COLOR {|| _GetColor(oBrowse) }

   DCBROWSECOL ELEMENT 2 PARENT oBrowse HEADER 'Full Price' WIDTH 5  ;
      GROUP 'DIALOG' PICTURE '99999.99';
      COLOR {|| _GetColor(oBrowse) }
   DCBROWSECOL ELEMENT 3 PARENT oBrowse HEADER 'Add Price' WIDTH 5 ;
      GROUP 'DIALOG' PICTURE '99999.99';
      COLOR {|| _GetColor(oBrowse) }

   DCGETOPTIONS ;
      HIDE ;
      BUSY "Please wait" ;
			RESIZE ;
      TABSTOP ;
      NOESCAPEKEY ;
      TOOLTIPCOLOR LCS_TOOLTIPCOLOR1, LCS_TOOLTIPCOLOR2;
      NOEDITNAVKEYS {||.f.}                    // No Edit Navigation Key - stop from wanting to go to another get

   DCREAD GUI TO lOK ;
      TITLE 'A La Carte' ;
      OPTIONS GetOptions ;
      EVAL {|o| SetAppWindow(o),;
			   o:lockUpdate(.t.),;   // suppress the automatic screen update
         o:Show(),;            // show screen
				 o:InvalidateRect() }

RETURN .t.

STATIC FUNCTION _GetColor(oBrowse)
   LOCAL cElemName := DC_GetColArray(1,oBrowse)
   cElemName := TRIM(DC_GetColArray(1,oBrowse))

   DO CASE
   CASE cElemName == EMPTY_ROW
      RETURN {GRA_CLR_WHITE,GRA_CLR_WHITE}
   CASE      cElemName == NO_PURCHASE
      RETURN {GRA_CLR_RED,GRA_CLR_WHITE}
   CASE      cElemName == NO_MORE_SALES_ALLOWED_LIMIT_EXCEEDED
      RETURN {GRA_CLR_RED,GRA_CLR_WHITE}
   CASE      cElemName == NO_MORE_SALES_ALLOWED
      RETURN {GRA_CLR_RED,GRA_CLR_WHITE}
   CASE      cElemName == NO_C_ITEMS
      RETURN {GRA_CLR_RED,GRA_CLR_WHITE}
   CASE      cElemName == NO_EXTRA_SALES
      RETURN {GRA_CLR_RED,GRA_CLR_WHITE}
   CASE      cElemName == NO_C_ITEMS_NO_EXTRA_SALES
      RETURN {GRA_CLR_RED,GRA_CLR_WHITE}
   CASE      cElemName == NO_EXTRA_SALES_LIMIT_EXCEEDED
      RETURN {GRA_CLR_RED,GRA_CLR_WHITE}
   CASE      cElemName == NO_MORE_EXTRA_SALES .OR. ;
         cElemName == PURCHASES_NOT_ALLOWED
      RETURN {GRA_CLR_RED,GRA_CLR_WHITE}
   CASE cElemName == PUR_TOTAL_SALE .OR. ;
         cElemName == PUR_RECEIPT .OR. ;
         cElemName == PUR_LINE .OR. ;
         cElemName == PUR_CHANGE
      RETURN {GRA_CLR_GREEN,GRA_CLR_WHITE}
   OTHERWISE
      RETURN {GRA_CLR_BLACK,GRA_CLR_WHITE}
   ENDCASE

RETURN  {GRA_CLR_BLACK,GRA_CLR_WHITE}

FUNCTION BrowPresII(nHeaderSize)
	DCQDEBUG nHeaderSize
RETURN ;
  { { XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE },            /* Header FG Color  */  ;
    { XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY },         /* Header BG Color  */  ;
    { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED }, /* Row Sep          */  ;
    { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED }, /* Col Sep          */  ;
    { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },            /* Row FG Color     */  ;
    { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },            /* Row BG Color     */  ;
    { XBP_PP_COL_DA_ROWHEIGHT, 16 },      /* Row Height  16     */  ;
    { XBP_PP_COL_HA_HEIGHT, nHeaderSize },                      /* Header Height    */  ;
    { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },            /* Hilite FG color  */  ;
    { XBP_PP_HILITE_BGCLR, GRA_CLR_YELLOW },           /* Hilite BG color  */  ;
    { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },            /* Footer FG Color  */   ;
    { XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY },         /* Footer BG Color  */  ;
    { XBP_PP_COL_FA_HEIGHT, 10 }                       /* Footer Height    */  ;
   }

