#INCLUDE "dcdialog.CH"

PROC appsys
RETURN

* ------------

FUNCTION Main()

LOCAL GetList[0], GetOptions, oBrowse, aDir

aDir := Directory()

@ 5,10 DCBROWSE oBrowse DATA aDir SIZE 30,10 PRESENTATION DC_BrowPres() ;
   RESIZE DCGUI_RESIZE_RESIZEONLY

DCBROWSECOL ELEMENT 1 HEADER '1' WIDTH 10 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER '2' WIDTH 10 PARENT oBrowse
DCBROWSECOL ELEMENT 3 HEADER '3' WIDTH 10 PARENT oBrowse

@ 16,10 DCPUSHBUTTON CAPTION 'Adjust ScrollBar' SIZE 20,2 ;
   ACTION {||AdjustScrollBar(oBrowse)}

DCGETOPTIONS RESIZE

DCREAD GUI ;
  OPTIONS GetOptions ;
  EVAL {||AdjustScrollBar( oBrowse) }

RETURN nil

* ------------

FUNCTION AdjustScrollBar( oBrowse)

LOCAL i, aChildList

aChildList := oBrowse:childList()

oBrowse:xbpstatic:setSize({oBrowse:xbpstatic:currentSize()[1]+15, ;
                           oBrowse:xbpstatic:currentSize()[2]+15})

FOR i := 1 TO Len(aChildList)

  IF aChildList[i]:isDerivedFrom('XbpScrollBar') .AND. ;
      aChildList[i]:type == XBPSCROLL_VERTICAL

    aChildList[i]:setSize({30,aChildList[i]:currentSize()[2]})
    aChildList[i]:setPos({aChildList[i]:currentPos()[1],30})

  ELSEIF aChildList[i]:isDerivedFrom('XbpScrollBar') .AND. ;
      aChildList[i]:type == XBPSCROLL_HORIZONTAL

    aChildList[i]:setSize({aChildList[i]:currentSize()[1],30})

  ENDIF

NEXT

aChildList := oBrowse:xbpstatic:childList()

FOR i := 1 TO Len(aChildList)

  IF !aChildList[i]:isDerivedFrom('XbpScrollBar')

    aChildList[i]:setPos({aChildList[i]:currentPos()[1], ;
                          aChildList[i]:currentPos()[2]+15})

  ENDIF

NEXT

RETURN nil


